/**
 * Project: MentDB
 * Description: Mentalese Database Engine
 * Website: http://www.mentdb.org
 * Twitter: https://twitter.com/mentalese_db
 * LinkedIn: https://www.linkedin.com/company/mentdb
 * Facebook: https://www.facebook.com/mentdb
 * Author: Jimmitry Payet
 * Website: http://www.jpayet.re
 * Mail: contact@jpayet.re
 * Locality: Reunion Island (French)
 */

package re.jpayet.mentdb.core.entity.concentration;

import org.json.simple.JSONObject;

import re.jpayet.mentdb.core.parameter.ParameterManager;

public class ConcentrationManager {
	
	public static JSONObject allConcentrations = new JSONObject();
	
	//Init the concentration depth numbers
	@SuppressWarnings("unchecked")
	public static void init(String user) throws Exception {

		ParameterManager.add(user, "C[symbol]", "200", "1");
		ParameterManager.add(user, "C[relation]", "200", "1");
		
		ParameterManager.add(user, "C[graph-symbol]", "5", "1");
		ParameterManager.add(user, "C[graph-relation]", "5", "1");

		ParameterManager.add(user, "C[stimulation-tab]", "25", "1");
		
		ParameterManager.add(user, "C[user]", "25", "1");
		ParameterManager.add(user, "C[language]", "25", "1");
		
		ParameterManager.add(user, "C[basic-search]", "10", "1");
		ParameterManager.add(user, "C[deep-search]", "10", "1");

		//To do ...
		ParameterManager.add(user, "C[emotion]", "25", "1");

		allConcentrations.put("C[symbol]", ParameterManager.get_value(user, "C[symbol]"));
		allConcentrations.put("C[relation]", ParameterManager.get_value(user, "C[relation]"));
		allConcentrations.put("C[graph-symbol]", ParameterManager.get_value(user, "C[graph-symbol]"));
		allConcentrations.put("C[graph-relation]", ParameterManager.get_value(user, "C[graph-relation]"));
		allConcentrations.put("C[stimulation-tab]", ParameterManager.get_value(user, "C[stimulation-tab]"));
		allConcentrations.put("C[user]", ParameterManager.get_value(user, "C[user]"));
		allConcentrations.put("C[language]", ParameterManager.get_value(user, "C[language]"));
		allConcentrations.put("C[basic-search]", ParameterManager.get_value(user, "C[basic-search]"));
		allConcentrations.put("C[deep-search]", ParameterManager.get_value(user, "C[deep-search]"));
		allConcentrations.put("C[emotion]", ParameterManager.get_value(user, "C[emotion]"));

	}
	
	//Load the concentration depth numbers
	@SuppressWarnings("unchecked")
	public static void load(String user) throws Exception {

		allConcentrations.put("C[symbol]", ParameterManager.get_value(user, "C[symbol]"));
		allConcentrations.put("C[relation]", ParameterManager.get_value(user, "C[relation]"));
		allConcentrations.put("C[graph-symbol]", ParameterManager.get_value(user, "C[graph-symbol]"));
		allConcentrations.put("C[graph-relation]", ParameterManager.get_value(user, "C[graph-relation]"));
		allConcentrations.put("C[stimulation-tab]", ParameterManager.get_value(user, "C[stimulation-tab]"));
		allConcentrations.put("C[user]", ParameterManager.get_value(user, "C[user]"));
		allConcentrations.put("C[language]", ParameterManager.get_value(user, "C[language]"));
		allConcentrations.put("C[basic-search]", ParameterManager.get_value(user, "C[basic-search]"));
		allConcentrations.put("C[deep-search]", ParameterManager.get_value(user, "C[deep-search]"));
		allConcentrations.put("C[emotion]", ParameterManager.get_value(user, "C[emotion]"));

	}
	
	//Show the concentration object
	public static JSONObject show(String user)  {

		return allConcentrations;

	}
	
	//Get the concentration depth number
	public static int getConcentrationDepth(String key) throws NumberFormatException, Exception {

		return Integer.parseInt(""+allConcentrations.get(key));

	}
	
	//Set the concentration depth number
	@SuppressWarnings("unchecked")
	public static void setConcentrationDepth(String user, String key, int depth) throws Exception {

		ParameterManager.unlook(user, key);
		ParameterManager.update(user, key, ""+depth);
		ParameterManager.look(user, key);
		
		allConcentrations.put(key, ""+depth);

	}

}
