/**
 * Project: MentDB
 * Project: MentDB
 * Description: Mentalese Database Engine
 * Website: http://www.mentdb.org
 * Twitter: https://twitter.com/mentalese_db
 * LinkedIn: https://www.linkedin.com/company/mentdb
 * Facebook: https://www.facebook.com/mentdb
 * Author: Jimmitry Payet
 * Website: http://www.jpayet.re
 * Mail: contact@jpayet.re
 * Locality: Reunion Island (French)
 */

package re.jpayet.mentdb.core.fx;

import java.io.File;
import java.io.FileReader;
import java.io.LineNumberReader;

import re.jpayet.mentdb.tools.Misc;

//The type class
public class FileFx {
	
	//Count the number of line in a directory
	public static String count_dir(String dirPath, String endOfFile) throws Exception {
		
		//Initialization
		int cnt = 0;
		File dir = new File(dirPath);
		String[] allFiles = dir.list();

		//Parse all files
		for(int i=0;i<allFiles.length;i++) {

			//get the current file
			String curFile = allFiles[i];

			//Check if a directory or a file
			if ((new File(dirPath+File.separator+curFile)).isDirectory()) {

				cnt += Long.parseLong(count_dir(dirPath+File.separator+curFile, endOfFile));

			} else {

				if (curFile.endsWith(endOfFile)) cnt += Long.parseLong(count_lines(dirPath+File.separator+curFile));

			}

		}

		//Return the number of line
		return ""+cnt;

	}

	//Count lines in a file
	public static String count_lines(String filePath) throws Exception {
		
		//Initialization
		LineNumberReader reader  = new LineNumberReader(new FileReader(filePath));
		int cnt = 0;
		@SuppressWarnings("unused")
		String lineRead = "";

		try {

			//Parse the file
			while ((lineRead = reader.readLine()) != null) {}

			//Get the number of line
			cnt = reader.getLineNumber(); 

		} catch (Exception e) {

			//Generate an error
			throw new Exception("Error: "+e.getMessage()+" (count_lines).");

		} finally {

			//Close the reader
			try {reader.close();} catch (Exception e) {}

		}

		//Return the number of line
		return ""+cnt;

	}

	//Create a new file
	public static String create(String filePath, String data) throws Exception {
		
		Misc.create(filePath, data);
		
		return "1";

	}

}
